#ifndef LIST_H
#define LIST_H

#define INBUF	4192

typedef struct TextList {
  struct TextList *next;
  int len;
  char data[0];
} TextList;

typedef struct TextList_dummy {
  TextList *next;
  int len;
} TextList_dummy;

typedef struct BlockNode {
  struct BlockNode *next;
  struct BlockNode *prev;
  TextList *text;
  TextList *text_end;
  short state;
  short change;
} BlockNode;

typedef struct Block {
  BlockNode *start;
  BlockNode *end;
} Block;

Block* data_load(FILE* in);
int data_write(FILE* out, Block* d);
int data_debug(Block* d);
void tl_prepend(BlockNode *bn, TextList *tl);
void tl_append(BlockNode *bn, TextList *tl);
int block_length(Block* bl);
int reduce(Block* bl);
void fix_change(BlockNode *start);
void block_insert(BlockNode* c, short state);

#endif
