#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include "list.h"
#include "tags.h"

int time_limit;

void usage(char* name)
{
  fprintf(stderr, "Usage: %s infile outfile time_limit\n", name);
  exit(1);
}

int reduce(Block* bl)
{
  int x, size;
  size=block_length(bl);
  fprintf(stderr, "New Partition Size=%d blocks\n", size);
  //data_debug(bl);
  while (1)
    {
      x=1;
      while(x)
	{
	  collapse_PL(bl);
/*   data_debug(bl); */
	  collapse_single(bl);
/*   data_debug(bl); */
	  collapse_cs(bl);
/*   data_debug(bl); */
	  x=collapse_redun(bl);
/*   data_debug(bl); */
	  size-=x;
	  fprintf(stderr, "Removed %d blocks to %d\n", x, size);
	  if (size==1)
	    return 0;
	}
      // Stage one complete, check if we're done
      if (size == 1)
	return 0;
      // Failed, go to stage two and try again
      //data_debug(bl);
      if (time(NULL)>time_limit)
	{
	  fprintf(stderr,"Time's up!\n");
	  exit(1);
	}
      fprintf(stderr, "\nPartitioning...\n");
      //return 0;  // Not until partitioning is set up...
/*       getchar(); */
      Partition(bl);
/*       return 0; */
      x=collapse_redun(bl);
      size=block_length(bl);
      fprintf(stderr, "Partition size reduced to %d\n", size);
    }
}

int main(int argc, char **argv)
{
  FILE *infile, *outfile;
  Block* top;
  if (argc<4)
    usage(argv[0]);
  time_limit=time(NULL)+atoi(argv[3])-40;
  // Step One: read in the file and save in list format
  infile=fopen(argv[1], "r");
  if (infile==NULL)
    {
      fprintf(stderr, "Unable to open %s\n", argv[1]);
      usage(argv[0]);
    }
  top=data_load(infile);
  // Step Two: do optimization
  reduce(top);
/*   while (x) */
/*     { */
/*       x=collapse_PL(top); */
/*       fprintf(stderr, "Removed %d blocks (collapse_PL)\n", x); */
/*       x=collapse_single(top); */
/*       fprintf(stderr, "Removed %d blocks (collapse_single)\n", x); */
/*       x=collapse_redun(top); */
/*       fprintf(stderr, "Removed %d blocks (collapse_redun)\n", x); */
/*     } */
  outfile=fopen(argv[2], "w");
  if (outfile==NULL)
    {
      fprintf(stderr, "Unable to open %s\n", argv[2]);
      usage(argv[0]);
    }
  fprintf(stderr,"%d blocks written\n", data_write(outfile, top));
  return 0;
}
