#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "tags.h"

const char cols[16]={0,'r','g','b','c','m','y','k','w',
		     0,0,0,0,0,0,0};

#define build_tag(id, str) if(state&id) {\
				buf[len++]='<';\
				strcpy(&buf[len],str);\
				len=strlen(buf);\
				buf[len++]='>'; }

#define build_invtag(id, str) if(state&id) {\
				buf[len++]='<';\
				buf[len++]='/';\
				strcpy(&buf[len],str);\
				len=strlen(buf);\
				buf[len++]='>'; }

// Entry tags (these can only start a tag)
TextList* make_tag_entry(short state)
{
  char buf[64];
  int len=0, x;
  TextList *tl;
  // Build the tags...
  build_tag(M_B, "B");
  build_tag(M_EM,"EM");
  build_tag(M_I, "I");
  build_tag(M_S, "S");
  build_tag(M_TT,"TT");
  // Less trivial tags
  // Underline: adds n underline tags
  if (state & M_U)
  {
    x=(state & M_U)>>8;
    for (;x;x--)
      {
	buf[len++]='<';
	buf[len++]='U';
	buf[len++]='>';
      }
  }
  // Size: sets the size
  if (state & M_SIZE)
    {
      buf[len++]='<';
      buf[len++]='0'-1+((state & M_SIZE)>>4);
      buf[len++]='>';
    }
  //Color: sets the color
  if (state & M_COL)
    {
      buf[len++]='<';
      buf[len++]=cols[state & M_COL];
      buf[len++]='>';
    }
  buf[len]=0;
  // Create the TextList structure
/*   fprintf(stderr, "Writing (%d) %s\n", len, buf); */
  tl=(TextList*)malloc(sizeof(TextList_dummy)+len);
  memcpy(tl->data,buf,len);
  tl->len=len;
  return tl;
}

// Exit tags
//   These have to be built in the opposite order as
//   the entry tags
TextList* make_tag_exit(short state)
{
  char buf[64];
  int len=0, x;
  TextList *tl;
  // Build the tags...
  // Less trivial tags
  //Color: sets the color
  if (state & M_COL)
    {
      buf[len++]='<';
      buf[len++]='/';
      buf[len++]=cols[state & M_COL];
      buf[len++]='>';
    }
  // Size: sets the size
  if (state & M_SIZE)
    {
      buf[len++]='<';
      buf[len++]='/';
      buf[len++]='0'-1+((state & M_SIZE)>>4);
      buf[len++]='>';
    }
  // Underline: adds n underline tags
  if (state & M_U)
  {
    x=(state & M_U)>>8;
    for (;x;x--)
      {
	buf[len++]='<';
	buf[len++]='/';
	buf[len++]='U';
	buf[len++]='>';
      }
  }
  build_invtag(M_TT,"TT");
  build_invtag(M_S, "S");
  build_invtag(M_I, "I");
  build_invtag(M_EM,"EM");
  build_invtag(M_B, "B");
  buf[len]=0;
  // Create the TextList structure
/*   fprintf(stderr, "Writing (%d) %s\n", len, buf); */
  tl=(TextList*)malloc(sizeof(TextList_dummy)+len);
  memcpy(tl->data,buf,len);
  tl->len=len;
  return tl;
}
